<!--
/**
 * K-onstruct CMS
 * Copyright (C) 2008-2011 Kevin Kis
 *
 * Formerly known as CECMS Content Management System
 *
 * PHP version 5
 * @copyright  2008-2011 Kevin Kis
 * @author     Kevin Kis <http://www.k-kombinat.de>
 *
 */


var blockflip = false;
var imagesdir = "media/uploads/images";

/**
 * Load on ready state
 */
$(function() {
    loadContent();
    initMCardHandler();
    initInfoBox();
    initLocalStorageEngine();
    initSessionStorageEngine();

});

var quizthemeshort = "Bankwesen verstehen";
var quiztheme = "Bankwesen verstehen";

qarray = jQuery.parseJSON('{\n\
"g1": {\n\
        "pos_symbol":"3-5", \n\
        "pos_notation" : "1-3", \n\
        "symbol":"Bankensystem.jpg", \n\
        "notation":"Bankensystem", \n\
        "infoboxcontent":"Gesamtheit aller öffentlichen und privaten Kreditinstitute und Unternehmen, die mit der Versorgung mit Geld, der Vermittlung von Krediten und dem Zahlungsverkehr beauftragt sind."},\n\
"g2": {\n\
        "pos_symbol":"1-2", \n\
        "pos_notation" : "4-5", \n\
        "symbol":"Trennbanksystem.jpg", \n\
        "notation":"Trennbanksystem", \n\
        "infoboxcontent":"Trennung von Geschäftsbanken und Investmentbanken sowie der Bankgeschäfte. In den USA erfolgt eine Trennung der Effekten-, Kredit- und Einlagengeschäften, in Japan trennt man kurz- und langfristige Finanzgeschäfte."},\n\
"g3": {\n\
        "pos_symbol":"1-5", \n\
        "pos_notation" : "2-2", \n\
        "symbol":"Universalbanksystem.jpg", \n\
        "notation":"Universalbank- system", \n\
        "infoboxcontent":"Vereint Geschäftsbanken und Investmentbanken unter einem Dach. Alle Bankgeschäfte (Effekten-, Kredit- und Einlagengeschäfte) können hier abgewickelt werden."},\n\
"g4": {\n\
        "pos_symbol":"2-1", \n\
        "pos_notation" : "4-1", \n\
        "symbol":"Geschaeftsbank.jpg", \n\
        "notation":"Geschäftsbanken", \n\
        "infoboxcontent":"Wirtschafts- und Dienstleistungsunternehmen im direkten Geschäft mit Bankkunden. Sie befassen sich mit der Verwaltung von Spareinlagen und der Abwicklung von Kreditgeschäften."},\n\
"g5": {\n\
        "pos_symbol":"4-3", \n\
        "pos_notation" : "1-4", \n\
        "symbol":"Investmentbank.jpg", \n\
        "notation":"Investment- banken", \n\
        "infoboxcontent":"Banken, die vereinfacht gesagt Handel mit Effekten, also verschiedenen Arten von Wertpapieren, betreiben. Sie investieren Gelder zu dem Zweck, für sich und ihre Kunden  Gewinne zu erzielen."},\n\
"g6": {\n\
        "pos_symbol":"4-4", \n\
        "pos_notation" : "1-1", \n\
        "symbol":"Sparkasse.jpg", \n\
        "notation":"Sparkassen", \n\
        "infoboxcontent":"Banken, die sich in der Trägerschaft von Städten und Gemeinden befinden und nach dem Regionalprinzip arbeiten, d.h. an eine Region gebunden sind. Z.B. Sparkassen und Landesbanken."},\n\
"g7": {\n\
        "pos_symbol":"3-2", \n\
        "pos_notation" : "3-3", \n\
        "symbol":"Genossenschaftsbank.jpg", \n\
        "notation":"Genossenschafts- banken", \n\
        "infoboxcontent":"Diese Banken tragen das Kürzel e.G. Ihre  Kunden können Anteile erwerben und erhalten dafür Stimmrecht (1 Stimme unabhängig von der Zahl ihrer Anteile). Z.B. Volks- und Raiffeisenbanken "},\n\
"g8": {\n\
        "pos_symbol":"2-5", \n\
        "pos_notation" : "4-2", \n\
        "symbol":"Kreditbank.jpg", \n\
        "notation":"Kreditbanken", \n\
        "infoboxcontent":"Bei diesen Banken handelt es sich um Aktiengesellschaften (AG). Aktionäre besitzen Stimmrechte nach Anzahl ihrer Aktien. Sie führen neben Kundengeschäften auch Kapitalmarktgeschäfte aus."},\n\
"g9": {\n\
        "pos_symbol":"2-3", \n\
        "pos_notation" : "3-1", \n\
        "symbol":"DeutscheBundesbank.jpg", \n\
        "notation":"Deutsche Bundesbank", \n\
        "infoboxcontent":"Führt die Aufsicht über alle deutschen Banken und gehört zum System der Europäischen Zentralbanken. Aufgabe ist u.a. für die Preisstabilität des Euro zu sorgen. Sie trägt damit zu den Zielen der Europäischen Zentralbank bei."},\n\
"g10":{\n\
        "pos_symbol":"2-4", \n\
        "pos_notation" : "3-4", \n\
        "symbol":"EuropaeischeZentralbank.jpg", \n\
        "notation":"Europäische Zentralbank", \n\
        "infoboxcontent":"Die Europäische Zentralbank (EZB) ist ein Organ der Europäischen Union. Die EZB wurde 1998 gegründet und ist die gemeinsame Währungsbehörde der Mitgliedstaaten der Europäischen Währungsunion. Zusammen mit den nationalen Zentralbanken (in Deutschland ist das die ‚Deutsche Bundesbank‘) bildet die EZB das Europäische System der Zentralbanken. Sitz der EZB ist Frankfurt."}\n\
}');



function loadContent() {

    // Set images and text
    for(key in qarray) {
        var notationposition = qarray[key].pos_notation;
        var notation = qarray[key].notation;
        var symbolposition = qarray[key].pos_symbol;
        var symbol = qarray[key].symbol;

        $('#pos-'+notationposition).append('<span class="visible0">'+notation+'</span>');
        $('#pos-'+notationposition).attr('rel',key);
        $('#pos-'+symbolposition).append('<img src="'+imagesdir+'/'+symbol+'" class="visible0" />');
        $('#pos-'+symbolposition).attr('rel',key);
    }

}

function initMCardHandler(){

    $('.mcard').click(function() {

        switchLocalStorageButtons("save");

        var opencards_wrapper = $('.opencard');

        if(blockflip == false) {
            var id= this.id;
            // show card by click
            if(!$('#'+id).hasClass('opencard')) {
                if(opencards_wrapper.length >1) {
                    hideallcards();
                    setTimeout(function(){
                        opencard(id);
                    },400);
                }else {
                    opencard(id);
                }
                hideInfoBoxes();
            }
        }
    })
}


function opencard (id) {
    $('#'+id).flip({
        direction:'rl',
        speed:200,
        color:"#fff",
        onBefore: function(){
            blockflip=true;
            $('#'+id).addClass('opencard');
            $('#'+id).children().removeClass("visible0");
        },
        onEnd: function(){
            enableInfoBoxes(id)
            blockflip=false;
        }
    })
}


function hidecard (id) {
    $('#'+id).flip({
        direction:'lr',
        speed:200,
        color:'#EDEDED',
        onBefore: function(){
            blockflip=true;
            $('#'+id).removeClass('opencard');
            $('#'+id).children().addClass("visible0");
        },
        onEnd: function(){
            blockflip=false;
        }
    });
}


function showallcards()  {

    $('.mcard').each(function() {
        var id = this.id;
        if(!$('#'+id).hasClass('opencard')) {
            opencard(id);
        }
    })

}
function hideallcards()  {

    $('.mcard').each(function() {
        var id = this.id;
        if($('#'+id).hasClass('opencard') && !$('#'+id).hasClass('closedpair')) {
            hidecard(id);
        }
    })
}

function enableInfoBoxes(data){


    var sethigherzindex = highestZindex(".infoborder") + 1;
    var startleftbfposition = rand(420, 722);
    var starttopbfposition = rand(0, 230);


    if($('#'+data.id).hasClass('opencard')) {

        var relvalue = $('#'+data.id).attr('rel');

        $('.infoborder[rel="'+relvalue+'"]').css({
            "left": startleftbfposition,
            "top": starttopbfposition,
            "z-index": sethigherzindex
        }).show();
    }
}


function enableInfoBoxesWithImages() {

    $('.navinfo').click(function(){

        var sethigherzindex = highestZindex(".infoborder") + 1;
        var startleftbfposition = rand(420, 722);
        var starttopbfposition = rand(0, 230);

        var relvalue = $(this).attr('rel');

        $('.infoborder[rel="'+relvalue+'"] h1').show();

        $('.infoborder[rel="'+relvalue+'"]').css({
            "left": startleftbfposition,
            "top": starttopbfposition,
            "z-index": sethigherzindex
        }).show();

    })
}


/**
 * Validate input values
 **/
function checK() {

    var key = new Array();
    var opencards_wrapper = $('.opencard');

    if(opencards_wrapper.length == 2) {

        opencards_wrapper.each(function() {
            key.push($('#'+this.id).attr('rel'));
        });

        if(key[0] == key[1] && typeof key[0] !== "undefined") {

            blockflip = true;

            opencards_wrapper.each(function() {
                $('#'+this.id).addClass('greenborder')
            });

            showMsgBox("Richtig!");

            setTimeout(function(){
                $('.msgbox').fadeOut();
                opencards_wrapper.css('visibility','hidden');
                opencards_wrapper.removeClass('opencard');
                opencards_wrapper.addClass('closedpair');
                moveCardstoNavigationCenter(key[0]);
                enableInfoBoxesWithImages();
                initNavScroll();
                blockflip = false;
            }, 1000);


        } else {

            showMsgBox("Leider falsch. <br />Versuch es nocheinmal.");
            setTimeout(function(){
                $('.msgbox').fadeOut();
            }, 1200);

        }
    }

}


function moveCardstoNavigationCenter(key) {

    var symbol = qarray[key].symbol;
    var notation = qarray[key].notation;
    $('#mcs_container ol').append('<li><div class="navinfo" rel="'+key+'"><img src="'+imagesdir+'/'+symbol+'" /> <span>'+notation+'</span></div></li>');

}

/**
 * LOCAL STORAGE HANDLER
 **/
function initLocalStorageEngine() {

    var btn = $('#storagebutton span');

    if (localStorage.length == 0) {
        switchLocalStorageButtons("save");

    } else{
        switchLocalStorageButtons("load");
    }

    btn.click(function(){

        if(btn.html() == "Laden") {
            loadFromLocalStorage();
            switchLocalStorageButtons("save");
        } else {
            saveToLocalStorage();
            showMsgBox("Die aktuellen Eingaben wurden im Browser gespeichert. <br />Bei erneutem Spielen am Anfang auf 'Laden' klicken, um mit diesem Lösungsstand weiter zu arbeiten.");
        }
        
        initNavScroll();
        enableInfoBoxesWithImages();
    });
}

function switchLocalStorageButtons(method) {

    var btn = $('#storagebutton span');

    if(method == "save"){
        btn.html('Speichern')
    } else {
        btn.html('Laden')
    }
}

function loadFromLocalStorage() {

    // reset navigation results
    $('#mcs_container ol').html('');

    var result = localStorage['resolved_pairs'].split(',');

    if(localStorage['resolved_pairs'].length > 0){
        for(var i=0;i<result.length;i++) {
            moveCardstoNavigationCenter(result[i]);
        }
    }

    $('.mcard').css({
        "visibility":"visible"
    });

    $('.mcard').each(function(){

        for(var i=0;i<result.length;i++) {
            if($(this).attr('rel') == result[i]){
                $(this).css({
                    "visibility":"hidden"
                });
            }
        }
    })
}

function saveToLocalStorage() {

    var sstorage = new Array();

    $('.navinfo').each(function(){
        sstorage.push($(this).attr('rel'));
    })

    localStorage['resolved_pairs'] = sstorage;

}


function resetLocalStorage() {
    localStorage.clear();
}
function resetSesssionStorage() {
    lsessionStorage.clear();
}



/**
 * SESSION STORAGE HANDLER
 **/
function initSessionStorageEngine(){
    var btn = $('#sessionbutton span');

    btn.click(function(){

        if(btn.html() == "Lösen") {
            saveToSessionStorage();
            solveMemory();
            switchSessionButtons("back");
        } else {
            loadFromSessionStorage();
            switchSessionButtons("solve");
        }

        initNavScroll();
        enableInfoBoxesWithImages();

    });
}


function switchSessionButtons(method) {

    var btn = $('#sessionbutton span');

    if(method == "solve"){
        btn.html('Lösen')
    } else {
        btn.html('Zurück')
    }
}

function saveToSessionStorage() {

    var sstorage = new Array();

    $('.navinfo').each(function(){
        sstorage.push($(this).attr('rel'));
    })

    sessionStorage['resolved_pairs'] = sstorage;

    // reset navigation results
    $('#mcs_container ol').html('');
}

function loadFromSessionStorage() {
    // reset navigation results
    $('#mcs_container ol').html('');

    var result = sessionStorage['resolved_pairs'].split(',');

    if(sessionStorage['resolved_pairs'].length > 0){

        for(var i=0;i<result.length;i++) {
            moveCardstoNavigationCenter(result[i]);
        }
    }

    $('.mcard').css({
        "visibility":"visible"
    });

    $('.mcard').each(function(){

        for(var i=0;i<result.length;i++) {
            if($(this).attr('rel') == result[i]){
                $(this).css({
                    "visibility":"hidden"
                });
            }
        }
    })
}

/**
 * Fullfill memory navigation with answers and empty playground
 */
function solveMemory() {
    $('.mcard').each(function(){
        $(this).css({
            "visibility":"hidden"
        });
    })

    for(key in qarray) {
        moveCardstoNavigationCenter(key);
    }

}


// Function to append and fill info boxes with content
// Initialise functionality
function initInfoBox() {    
    
    for(key in qarray) { 
       
        var infoheader = '<img src="'+imagesdir+'/'+qarray[key].symbol+'"  /> <span>'+qarray[key].notation+'</span>';
        var infoboxcontent = qarray[key].infoboxcontent;
        $('#MainBorder').append('<div class="infoborder" rel="'+key+'" style="display:none;"><div class="infobox_close"></div><h1 style="display:none;">'+infoheader+'</h1><p>'+infoboxcontent+'</p></div>');
        
    }    
    
    // focussierte infobox bekommt höchsten zindex
    $(".infoborder").click(function(){
        var sethigherzindex = highestZindex(".infoborder") + 1;
        $(this).css("z-index",sethigherzindex);
    });
    
    //set draggable
    $('.infoborder').draggable();
    
    //init close button
    $('.infobox_close').click(function(){
        $(this).parent().hide();
    })
}

function hideInfoBoxes() {
    $('.infoborder').hide();
}